diff --git a/plugins/dell/fu-plugin-dell.c b/plugins/dell/fu-plugin-dell.c
index 552c8aeb17..212a3b8b3a 100644
--- a/plugins/dell/fu-plugin-dell.c
+++ b/plugins/dell/fu-plugin-dell.c
@@ -627,7 +627,7 @@ fu_plugin_dell_detect_tpm (FuPlugin *plugin, GError **error)
 	fu_device_add_flag (dev, FWUPD_DEVICE_FLAG_INTERNAL);
 	fu_device_add_flag (dev, FWUPD_DEVICE_FLAG_REQUIRE_AC);
 	fu_device_add_icon (dev, "computer");
-	fu_device_set_metadata (dev, FU_DEVICE_METADATA_UEFI_DEVICE_KIND, "system-firmware");
+	fu_device_set_metadata (dev, FU_DEVICE_METADATA_UEFI_DEVICE_KIND, "dell-tpm-firmware");
 	if ((out->status & TPM_OWN_MASK) == 0 && out->flashes_left > 0) {
 		if (fu_plugin_dell_capsule_supported (plugin)) {
 			fu_device_add_flag (dev, FWUPD_DEVICE_FLAG_UPDATABLE);
@@ -679,63 +679,6 @@ fu_plugin_dell_detect_tpm (FuPlugin *plugin, GError **error)
 	return TRUE;
 }
 
-gboolean
-fu_plugin_unlock (FuPlugin *plugin, FuDevice *device, GError **error)
-{
-	FuDevice *device_alt = NULL;
-	FwupdDeviceFlags device_flags_alt = 0;
-	guint flashes_left = 0;
-	guint flashes_left_alt = 0;
-
-	/* for unlocking TPM1.2 <-> TPM2.0 switching */
-	g_debug ("Unlocking upgrades for: %s (%s)", fu_device_get_name (device),
-		 fu_device_get_id (device));
-	device_alt = fu_device_get_alternate (device);
-	if (device_alt == NULL) {
-		g_set_error (error,
-			     FWUPD_ERROR,
-			     FWUPD_ERROR_NOT_SUPPORTED,
-			     "No alternate device for %s",
-			     fu_device_get_name (device));
-		return FALSE;
-	}
-	g_debug ("Preventing upgrades for: %s (%s)", fu_device_get_name (device_alt),
-		 fu_device_get_id (device_alt));
-
-	flashes_left = fu_device_get_flashes_left (device);
-	flashes_left_alt = fu_device_get_flashes_left (device_alt);
-	if (flashes_left == 0) {
-		/* flashes left == 0 on both means no flashes left */
-		if (flashes_left_alt == 0) {
-			g_set_error (error,
-				     FWUPD_ERROR,
-				     FWUPD_ERROR_NOT_SUPPORTED,
-				     "ERROR: %s has no flashes left.",
-				     fu_device_get_name (device));
-		/* flashes left == 0 on just unlocking device is ownership */
-		} else {
-			g_set_error (error,
-				     FWUPD_ERROR,
-				     FWUPD_ERROR_NOT_SUPPORTED,
-				     "ERROR: %s is currently OWNED. "
-				     "Ownership must be removed to switch modes.",
-				     fu_device_get_name (device_alt));
-		}
-		return FALSE;
-	}
-
-
-	/* clone the info from real device but prevent it from being flashed */
-	device_flags_alt = fu_device_get_flags (device_alt);
-	fu_device_set_flags (device, device_flags_alt);
-	fu_device_set_flags (device_alt, device_flags_alt & ~FWUPD_DEVICE_FLAG_UPDATABLE);
-
-	/* make sure that this unlocked device can be updated */
-	fu_device_set_version (device, "0.0.0.0");
-
-	return TRUE;
-}
-
 void
 fu_plugin_device_registered (FuPlugin *plugin, FuDevice *device)
 {
diff --git a/plugins/uefi/fu-plugin-uefi.c b/plugins/uefi/fu-plugin-uefi.c
index e16970abd3..44876910c1 100644
--- a/plugins/uefi/fu-plugin-uefi.c
+++ b/plugins/uefi/fu-plugin-uefi.c
@@ -638,6 +638,73 @@ fu_plugin_uefi_ensure_efivarfs_rw (GError **error)
 	return TRUE;
 }
 
+gboolean
+fu_plugin_unlock (FuPlugin *plugin, FuDevice *device, GError **error)
+{
+	FuUefiDevice *device_uefi = FU_UEFI_DEVICE (device);
+	FuDevice *device_alt = NULL;
+	FwupdDeviceFlags device_flags_alt = 0;
+	guint flashes_left = 0;
+	guint flashes_left_alt = 0;
+
+	if (fu_uefi_device_get_kind (device_uefi) !=
+	    FU_UEFI_DEVICE_KIND_DELL_TPM_FIRMWARE) {
+		g_set_error (error,
+			     FWUPD_ERROR,
+			     FWUPD_ERROR_NOT_SUPPORTED,
+			     "Unable to unlock %s",
+			     fu_device_get_name (device));
+		return FALSE;
+	}
+
+	/* for unlocking TPM1.2 <-> TPM2.0 switching */
+	g_debug ("Unlocking upgrades for: %s (%s)", fu_device_get_name (device),
+		 fu_device_get_id (device));
+	device_alt = fu_device_get_alternate (device);
+	if (device_alt == NULL) {
+		g_set_error (error,
+			     FWUPD_ERROR,
+			     FWUPD_ERROR_NOT_SUPPORTED,
+			     "No alternate device for %s",
+			     fu_device_get_name (device));
+		return FALSE;
+	}
+	g_debug ("Preventing upgrades for: %s (%s)", fu_device_get_name (device_alt),
+		 fu_device_get_id (device_alt));
+
+	flashes_left = fu_device_get_flashes_left (device);
+	flashes_left_alt = fu_device_get_flashes_left (device_alt);
+	if (flashes_left == 0) {
+		/* flashes left == 0 on both means no flashes left */
+		if (flashes_left_alt == 0) {
+			g_set_error (error,
+				     FWUPD_ERROR,
+				     FWUPD_ERROR_NOT_SUPPORTED,
+				     "ERROR: %s has no flashes left.",
+				     fu_device_get_name (device));
+		/* flashes left == 0 on just unlocking device is ownership */
+		} else {
+			g_set_error (error,
+				     FWUPD_ERROR,
+				     FWUPD_ERROR_NOT_SUPPORTED,
+				     "ERROR: %s is currently OWNED. "
+				     "Ownership must be removed to switch modes.",
+				     fu_device_get_name (device_alt));
+		}
+		return FALSE;
+	}
+
+	/* clone the info from real device but prevent it from being flashed */
+	device_flags_alt = fu_device_get_flags (device_alt);
+	fu_device_set_flags (device, device_flags_alt);
+	fu_device_set_flags (device_alt, device_flags_alt & ~FWUPD_DEVICE_FLAG_UPDATABLE);
+
+	/* make sure that this unlocked device can be updated */
+	fu_device_set_version (device, "0.0.0.0");
+
+	return TRUE;
+}
+
 gboolean
 fu_plugin_coldplug (FuPlugin *plugin, GError **error)
 {
diff --git a/plugins/uefi/fu-uefi-device.c b/plugins/uefi/fu-uefi-device.c
index 2cf3933ba2..d5111d6ec0 100644
--- a/plugins/uefi/fu-uefi-device.c
+++ b/plugins/uefi/fu-uefi-device.c
@@ -45,6 +45,8 @@ fu_uefi_device_kind_to_string (FuUefiDeviceKind kind)
 		return "uefi-driver";
 	if (kind == FU_UEFI_DEVICE_KIND_FMP)
 		return "fmp";
+	if (kind == FU_UEFI_DEVICE_KIND_DELL_TPM_FIRMWARE)
+		return "dell-tpm-firmware";
 	return NULL;
 }
 
@@ -59,6 +61,8 @@ fu_uefi_device_kind_from_string (const gchar *kind)
 		return FU_UEFI_DEVICE_KIND_UEFI_DRIVER;
 	if (g_strcmp0 (kind, "fmp") == 0)
 		return FU_UEFI_DEVICE_KIND_FMP;
+	if (g_strcmp0 (kind, "dell-tpm-firmware") == 0)
+		return FU_UEFI_DEVICE_KIND_DELL_TPM_FIRMWARE;
 	return FU_UEFI_DEVICE_KIND_UNKNOWN;
 }
 
diff --git a/plugins/uefi/fu-uefi-device.h b/plugins/uefi/fu-uefi-device.h
index d8b903ac6d..0bb2d6cfc9 100644
--- a/plugins/uefi/fu-uefi-device.h
+++ b/plugins/uefi/fu-uefi-device.h
@@ -23,6 +23,7 @@ typedef enum {
 	FU_UEFI_DEVICE_KIND_DEVICE_FIRMWARE,
 	FU_UEFI_DEVICE_KIND_UEFI_DRIVER,
 	FU_UEFI_DEVICE_KIND_FMP,
+	FU_UEFI_DEVICE_KIND_DELL_TPM_FIRMWARE,
 	FU_UEFI_DEVICE_KIND_LAST
 } FuUefiDeviceKind;
 
